Index: trunk/LMDZ.TITAN/libf/muphytitan/cfgparse.F90
===================================================================
--- trunk/LMDZ.TITAN/libf/muphytitan/cfgparse.F90	(revision 1896)
+++ trunk/LMDZ.TITAN/libf/muphytitan/cfgparse.F90	(revision 1897)
@@ -2006,5 +2062,5 @@
       CHARACTER(len=:), INTENT(out), ALLOCATABLE :: incpath
         !! A string with the filepath to be included if '#include' statement is found, empty string otherwise
-      LOGICAL :: res 
+      LOGICAL :: res
         !! .true. if line is a comment or an empty string, .false. otherwise
       CHARACTER(len=:), ALLOCATABLE :: copy
@@ -2017,5 +2073,5 @@
         ! search for include statement
         ! IMPORTANT: assume that there is only a path after include statement
-        IF (INDEX(copy,"#include ") == 1) incpath = TRIM(ADJUSTL(copy(10:)))
+        IF (INDEX(copy,"#include ") == 1) incpath = remove_quotes(TRIM(ADJUSTL(copy(10:))))
       ENDIF
       RETURN
@@ -2046,5 +2102,5 @@
   SUBROUTINE insertionSort(opts)
     !! Sort an array of Options using insertion sort algorithm
-    TYPE(option), INTENT(inout), DIMENSION(:) :: opts !! Array to sort. 
+    TYPE(option), INTENT(inout), DIMENSION(:) :: opts !! Array to sort.
     TYPE(option) :: temp
     INTEGER :: i, j
@@ -2058,5 +2114,5 @@
         ELSE
           EXIT
-        ENDIF 
+        ENDIF
       ENDDO
       opts(j+1) = temp
@@ -2065,28 +2121,4 @@
   END SUBROUTINE insertionSort
 
-  FUNCTION free_lun() RESULT(lu)
-    !> Get the first free logical unit
-    !!
-    !! The function loops from 7 to 9999 and returns the first free logical unit.
-    !! @note
-    !! According to Fortran standard, the maximum value for a lun is processor
-    !! dependent. I just assume that [7,9999] is a valid range and I believe that 
-    !! 9992 files to be opened is far enough for any program !
-    !! @note
-    !! If you intend to use loggers object from this library, you should keep in
-    !! mind that loggers open files with the first free logical unit. Consequently
-    !! if you need to perform I/O operations you should use this function to get a
-    !! free lun instead of just randomly set a lun ! 
-    INTEGER :: lu
-      !! First free logical unit in the range [7,999]  or -1 if no lun is available
-    INTEGER, PARAMETER :: mxlu = 9999
-    LOGICAL :: notfree
-    lu = 6 ; notfree = .true.
-    DO WHILE(notfree.AND.lu<=mxlu)
-      lu=lu+1 ; INQUIRE(unit=lu,OPENED=notfree)
-    ENDDO
-    IF (lu >= mxlu) lu = -1
-  END FUNCTION free_lun
-
 END MODULE CFGPARSE
 
Index: trunk/LMDZ.TITAN/libf/muphytitan/config/config.ne15.cfg
===================================================================
--- trunk/LMDZ.TITAN/libf/muphytitan/config/config.ne15.cfg	(revision 1897)
+++ trunk/LMDZ.TITAN/libf/muphytitan/config/config.ne15.cfg	(revision 1897)
@@ -0,0 +1,99 @@
+# YAMMS model parameters
+# ======================
+
+### Model global parameters 
+###------------------------
+# Monomer radius (m)
+rm                     = 50e-9
+# Fractal dimension
+df                     = 2.0
+# Aerosol density (kg.m-3)
+rho_aer                = 1000.
+# Enable/disable Haze production process 
+haze_production        = T
+# Enable/disable Haze coagulation process 
+haze_coagulation       = T
+# Coagulation interactions, a combination of:
+#    0 - no interactions (same as haze_coagulation == F)
+#    1 - SS interactions
+#    2 - SF interactions
+#    4 - FF interactions.
+# (for example: 5 = 4+1 --> SS and FF coagulation only)
+haze_coag_interactions = 7
+# Enable/disable Haze sedimentation process 
+haze_sedimentation     = T
+# Disable Fiadero correction for sedimentation process
+no_fiadero             = F
+# Fiadero correction minimum ratio threshold
+fiadero_min_ratio      = 0.1
+# Fiadero correction maximum ratio threshold
+fiadero_max_ratio      = 10.
+# Force settling velocity to M0
+wsed_m0 = T
+# Force settling velocity to M3
+wsed_m3 = F
+# Enable/disable clouds sedimentation process
+# (automatically set to F if clouds microphysics is not enabled)
+clouds_sedimentation   = T
+# Enable/disable clouds nucleation and condensation processes
+# (automatically set to F if clouds microphysics is not enabled)
+clouds_nuc_cond        = T
+# Condensible species configuration file
+# (not needed if clouds microphysics is not enabled)
+specie_cfg             = ../datagcm/microphysics/mp2m_species.cfg
+
+# Enable/disable spherical mode transfert probability
+transfert_probability = T
+# Path of the spherical mode transfert probability look-up tables file
+# (optional if 'transfert_probability' is False) 
+ps2s_file             = ../datagcm/microphysics/mmp_ps2s_rm50_ne15.nc
+
+# Electric charging coagulation correction
+# If set to .false. then no correction is assumed
+electric_charging     = T 
+# Path of the electric charging correction factor.
+# (optional if 'electric_charging' is False) 
+mq_file               = ../datagcm/microphysics/mmp_qmean_rm50_ne15.nc
+
+#  alpha_X sections contain the parameters of the inter-moments relation function for
+#  the mode X: either spherical (s) or fractal (f)
+#  dndr_X sections contain the parameters of the size-distribution law of the mode X
+[alpha_s]
+a =   1.5044478E-02,  -2.0948806E-01,  -1.5824302E+02,   1.1597818E-01,   9.9502283E-02,  -1.1223796E-01
+b =  -2.8622255E-01,   7.7089599E+00,  -1.7000626E+02,   2.6012143E+00,   5.5138784E-01,   9.2024747E-01
+c =  -3.0205020E-02,  -3.5510239E+01,  -2.0306468E+02,  -1.3605159E+01,  -4.1653422E+00,  -4.2571698E+00
+[dndr_s]
+rc = 4.58219580180634588E-007
+a0 = 86144.861255561875
+c  = 0d0
+a  = 2.48333861883769357E-040, 1.46076790655632173E-013, 1.71525517568997062E-009,
+    1.80855172875974993E-019, 1.48212594918347503E-047, 6.87247318898338451E-081
+b  = 59.518212357684796, 15.507500262021228, -5.4179933012448069,
+    -9.3500794017892854, -18.207927270524777, -27.248924688740562
+[alpha_f]
+a =   1.5044478E-02,  -2.0948806E-01,  -1.5824302E+02,   1.1597818E-01,   9.9502283E-02,  -1.1223796E-01
+b =  -2.8622255E-01,   7.7089599E+00,  -1.7000626E+02,   2.6012143E+00,   5.5138784E-01,   9.2024747E-01
+c =  -3.0205020E-02,  -3.5510239E+01,  -2.0306468E+02,  -1.3605159E+01,  -4.1653422E+00,  -4.2571698E+00
+[dndr_f]
+rc = 4.58219580180634588E-007
+a0 = 86144.861255561875
+c  = 0d0
+a  = 2.48333861883769357E-040, 1.46076790655632173E-013, 1.71525517568997062E-009,
+    1.80855172875974993E-019, 1.48212594918347503E-047, 6.87247318898338451E-081
+b  = 59.518212357684796, 15.507500262021228, -5.4179933012448069,
+    -9.3500794017892854, -18.207927270524777, -27.248924688740562
+
+# ================= #
+# b^T_k cofficients #
+# ================= #
+# This section gathers the values of all the btk coefficient used in the coagulation
+# equations for the free-molecular regime.
+[btks]
+bt0 = 0.73d0, 0.73d0, 0.75d0, 0.99d0, 0.00d0
+bt3 = 0.97d0, 0.97d0, 0.00d0, 0.99d0, 0.99d0
+
+[optics]
+optic_file = /path/to/optics_look_up_table.nc
+
+
+
Index: trunk/LMDZ.TITAN/libf/muphytitan/csystem.c
===================================================================
--- trunk/LMDZ.TITAN/libf/muphytitan/csystem.c	(revision 1896)
+++ trunk/LMDZ.TITAN/libf/muphytitan/csystem.c	(revision 1897)
@@ -1,5 +1,5 @@
-/* Copyright Jérémie Burgalat (2010-2015)
- * 
- * burgalat.jeremie@gmail.com
+/* Copyright Jérémie Burgalat (2010-2015,2017)
+ * 
+ * jeremie.burgalat@univ-reims.fr
  * 
  * This software is a computer program whose purpose is to provide configuration 
@@ -38,4 +38,5 @@
 #include <stdio.h>
 #include <limits.h>
+#include <string.h>
 #include <libgen.h>
 #include <sys/param.h>  // MAXPATHLEN
@@ -49,5 +50,4 @@
 #include <time.h>
 #include <unistd.h>
-
 #include "csystem.h"
 
@@ -270,4 +270,56 @@
 }
 
+
+int c_copy(const char *to, const char *from) {
+  int fd_to, fd_from;
+  char buf[4096];
+  ssize_t nread;
+  int saved_errno;
+
+  fd_from = open(from, O_RDONLY);
+  if (fd_from < 0)
+    return -1;
+
+  fd_to = open(to, O_WRONLY | O_CREAT | O_EXCL, 0666);
+  if (fd_to < 0)
+    goto out_error;
+
+  while (nread = read(fd_from, buf, sizeof buf), nread > 0) {
+    char *out_ptr = buf;
+    ssize_t nwritten;
+
+    do {
+      nwritten = write(fd_to, out_ptr, nread);
+
+      if (nwritten >= 0) {
+        nread -= nwritten;
+        out_ptr += nwritten;
+      } else if (errno != EINTR) {
+        goto out_error;
+      }
+    } while (nread > 0);
+  }
+
+  if (nread == 0) {
+    if (close(fd_to) < 0) {
+      fd_to = -1;
+      goto out_error;
+    }
+    close(fd_from);
+    /* Success! */
+    return 0;
+  }
+
+out_error:
+  saved_errno = errno;
+
+  close(fd_from);
+  if (fd_to >= 0)
+    close(fd_to);
+
+  errno = saved_errno;
+  return 1;
+}
+
 /* Remove file from filesytem */
 int c_remove(const char *path){
@@ -490,66 +542,149 @@
 }
 
-/* This verison of realpath was a dumb attempt to get a resolved path
- * that may not exist. As a matter of fact, it cannot cover all range 
- * of possibilities.
- * Thus it has been removed. The current verison of c_realpath simply
- * uses POSIX realpath and returns CWD if no path is given...
+/*
+ * Author:  David Robert Nadeau
+ * Site:    http://NadeauSoftware.com/
+ * License: Creative Commons Attribution 3.0 Unported License
+ *          http://creativecommons.org/licenses/by/3.0/deed.en_US
+ *
+ * Cross-plateform way to get memory usage at a given time in fucking bytes !!
+ *
+ * Usage:
+ *
+ * size_t currentSize = getCurrentRSS( );
+ * size_t peakSize    = getPeakRSS( );
  */
 
-/* Get the realpath of input path and saves it in output path */ 
-/*
-char* c_realpath(const char *input){
-  char *in,*output, *cur,*tmp,*res,*cwd ;
-  int c,om,rm,im; 
-  output = NULL;
-  cwd = c_getcwd();
-  if(!strlen(input))
-    return cwd;
-  // check (ugly) if path is absolute
-  if (input[0] == '/') {
-    in = strdup(input);
-  }else{
-    fprintf(stderr,"+++ C( in): %s\n",input);
-    in = malloc((strlen(input)+strlen(cwd)+2)*sizeof(char));
-    strncpy(in, cwd, strlen(cwd)); 
-    strncpy(&in[strlen(cwd)+1], input, strlen(input)); 
-    in[strlen(cwd)] = '/';
-    in[strlen(input)+strlen(cwd)+1] = '\0';
-  }
-  fprintf(stderr,"C( in): %s\n",in);
-  c = om = im = strlen(in);
-  tmp = malloc((c+1)*sizeof(char)); 
-  tmp[c] ='\0';
-  // search for the deepest existing directory in "input" path
-  while(c != 0 && (res = realpath(tmp,NULL)) == NULL){
-    // search for the next / from the right (i.e. parent directory)
-    for (cur=tmp+strlen(tmp) ; *cur != '/' && cur != tmp ; cur--, c--);
-    free(tmp) ; tmp = malloc((c+1)*sizeof(char)); 
-    strncpy(tmp, in, c); tmp[c] ='\0';
-  }
-  free(tmp);
-  // On error: null string
-  if (c == 0 || (res==NULL)) {
-    output = (char *)malloc(sizeof(char));
-    output[0]='\0'; 
-    return output; 
-  }
-  // no error: allocate output string
-  rm = strlen(res);
-  om += rm-c;
-  output = (char *)malloc(om*sizeof(char));
-  strncpy(output,res,rm);
-  // Here we could have a bug:
-  //    If the path does not exist and contains .. or . references after the deepest
-  //    existing directory, it will simply be appended !
-  //    Thus we can never resolve the path.
-  if (c != im)
-    strncpy(output+rm,in+c,im-c);
-    //strncpy(output+rm,in+c,im-c-1);
-  output[om] = '\0';
-  fprintf(stderr,"C(tmp): %s\n",res);
-  fprintf(stderr,"C(out): %s\n",output);
-  free(res) ;
-  return output;
-}
-*/
+#if defined(_WIN32)
+#include <windows.h>
+#include <psapi.h>
+#elif defined(__unix__) || defined(__unix) || defined(unix) || (defined(__APPLE__) && defined(__MACH__))
+#include <sys/resource.h>
+#if defined(__APPLE__) && defined(__MACH__)
+#include <mach/mach.h>
+#elif(defined(_AIX) || defined(__TOS__AIX__)) ||                                                                               \
+    (defined(__sun__) || defined(__sun) || defined(sun) && (defined(__SVR4) || defined(__svr4__)))
+#include <procfs.h>
+#endif
+#endif
+
+/**
+ * Returns the peak (maximum so far) resident set size (physical
+ * memory use) measured in bytes, or zero if the value cannot be
+ * determined on this OS.
+ */
+size_t c_getPeakRSS() {
+#if defined(_WIN32)
+    /* Windows -------------------------------------------------- */
+    PROCESS_MEMORY_COUNTERS info;
+    GetProcessMemoryInfo(GetCurrentProcess(), &info, sizeof(info));
+    return (size_t)info.PeakWorkingSetSize;
+
+#elif(defined(_AIX) || defined(__TOS__AIX__)) ||                                                                               \
+    (defined(__sun__) || defined(__sun) || defined(sun) && (defined(__SVR4) || defined(__svr4__)))
+    /* AIX and Solaris ------------------------------------------ */
+    struct psinfo psinfo;
+    int fd = -1;
+    if ((fd = open("/proc/self/psinfo", O_RDONLY)) == -1)
+        return (size_t)0L; /* Can't open? */
+    if (read(fd, &psinfo, sizeof(psinfo)) != sizeof(psinfo)) {
+        close(fd);
+        return (size_t)0L; /* Can't read? */
+    }
+    close(fd);
+    return (size_t)(psinfo.pr_rssize * 1024L);
+
+#elif defined(__unix__) || defined(__unix) || defined(unix) || (defined(__APPLE__) && defined(__MACH__))
+    /* BSD, Linux, and OSX -------------------------------------- */
+    struct rusage rusage;
+    getrusage(RUSAGE_SELF, &rusage);
+#if defined(__APPLE__) && defined(__MACH__)
+    return (size_t)rusage.ru_maxrss;
+#else
+    return (size_t)(rusage.ru_maxrss * 1024L);
+#endif
+
+#else
+    /* Unknown OS ----------------------------------------------- */
+    return (size_t)0L; /* Unsupported. */
+#endif
+}
+
+/**
+ * Returns the current resident set size (physical memory use) measured
+ * in bytes, or zero if the value cannot be determined on this OS.
+ */
+size_t c_getCurrentRSS() {
+#if defined(_WIN32)
+    /* Windows -------------------------------------------------- */
+    PROCESS_MEMORY_COUNTERS info;
+    GetProcessMemoryInfo(GetCurrentProcess(), &info, sizeof(info));
+    return (size_t)info.WorkingSetSize;
+
+#elif defined(__APPLE__) && defined(__MACH__)
+    /* OSX ------------------------------------------------------ */
+    struct mach_task_basic_info info;
+    mach_msg_type_number_t infoCount = MACH_TASK_BASIC_INFO_COUNT;
+    if (task_info(mach_task_self(), MACH_TASK_BASIC_INFO, (task_info_t)&info, &infoCount) != KERN_SUCCESS)
+        return (size_t)0L; /* Can't access? */
+    return (size_t)info.resident_size;
+
+#elif defined(__linux__) || defined(__linux) || defined(linux) || defined(__gnu_linux__)
+    /* Linux ---------------------------------------------------- */
+    long rss = 0L;
+    FILE *fp = NULL;
+    if ((fp = fopen("/proc/self/statm", "r")) == NULL)
+        return (size_t)0L; /* Can't open? */
+    if (fscanf(fp, "%*s%ld", &rss) != 1) {
+        fclose(fp);
+        return (size_t)0L; /* Can't read? */
+    }
+    fclose(fp);
+    return (size_t)rss * (size_t)sysconf(_SC_PAGESIZE);
+
+#else
+    /* AIX, BSD, Solaris, and Unknown OS ------------------------ */
+    return (size_t)0L; /* Unsupported. */
+#endif
+}
+
+
+ 
+/* Get some informatiosn about the OS memory usage (from /proc/meminfo) */
+int c_getSystemMemory(long long int *m_total,long long int *m_available,long long int *m_free){
+    FILE* fp;
+    char buf[1024];
+    char *tmp,*p;
+    int ts;
+    long long int mem1 = 0L,mem2 = 0L,mem3 = 0L;
+    if (m_total) (*m_total) = mem1;
+    if (m_available) (*m_free) = mem2;
+    if (m_free) (*m_free) = mem3;
+    if ((fp = fopen("/proc/meminfo", "r")) == NULL)  
+        return 1;
+    while (fgets(buf, sizeof(buf), fp) != NULL){
+        ts = strlen(buf) - 1; buf[ts] = '\0'; 
+        tmp = strndup(&buf[0],ts);
+        // check our 3 cases
+        if (ts >= 9 && !strncmp(tmp,"MemTotal:",9)){
+            // extract the two first tokens.
+            p=strtok(tmp, " "); p=strtok(NULL, " ");
+            // convert the value.
+            mem1 = strtoll(p,NULL,10);
+        }
+        if (ts >= 13 && !strncmp(tmp,"MemAvailable:",13)){
+            p=strtok(tmp, " "); p=strtok(NULL, " "); 
+            mem2 = strtoll(p,NULL,10);
+        }    
+        if (ts >= 8 && !strncmp(tmp,"MemFree:",8)){
+            p=strtok(tmp, " "); p=strtok(NULL, " "); 
+            mem3 = strtoll(p,NULL,10);
+        }
+        free(tmp);
+    }
+    fclose(fp);
+    if (m_total) (*m_total) = mem1;
+    if (m_available) (*m_available) = mem2;
+    if (m_free) (*m_free) = mem3;
+    return 0;
+}
Index: trunk/LMDZ.TITAN/libf/muphytitan/csystem.h
===================================================================
--- trunk/LMDZ.TITAN/libf/muphytitan/csystem.h	(revision 1896)
+++ trunk/LMDZ.TITAN/libf/muphytitan/csystem.h	(revision 1897)
@@ -1,5 +1,5 @@
-/* Copyright Jérémie Burgalat (2010-2015)
- * 
- * burgalat.jeremie@gmail.com
+/* Copyright Jérémie Burgalat (2010-2015,2017)
+ * 
+ * jeremie.burgalat@univ-reims.fr
  * 
  * This software is a computer program whose purpose is to provide configuration 
@@ -31,5 +31,5 @@
  * The fact that you are presently reading this means that you have had
  * knowledge of the CeCILL-B license and that you accept its terms.
- *//* csystem.h */
+ */
 
 
@@ -172,4 +172,13 @@
  */ 
 int c_mkdir(const char *path, mode_t mode);
+
+
+/**
+ * Copy file to another.
+ * @param to A C string with the new filepath
+ * @param from A C string with the filepath to copy
+ * @return An integer with 0 on success, 1 on failure.
+ */
+int c_copy(const char *to, const char *from);
 
 /**
@@ -255,2 +264,19 @@
 int c_termsize(int *rows,int *cols);
 
+/**
+ * Get the current resident set size memory used by the program.
+ */
+size_t c_getCurrentRSS();
+
+/**
+ * Get the peak resident set size memory used by the program.
+ */
+size_t c_getPeakRSS();
+
+/**
+ * Get global memory usage informations.
+ *
+ * Note: The method attempts to read /proc/meminfo. If the file does not exists, all the given output arguments are
+ * set to zero.
+ */
+int c_getSystemMemory(long long int *m_total,long long int *m_available,long long int *m_free);
